(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/material/button'), require('@angular/material/checkbox'), require('@angular/material/dialog'), require('@angular/material/input'), require('@angular/material/progress-bar'), require('@angular/material/progress-spinner'), require('@angular/material/select'), require('@angular/material/tooltip'), require('@angular/common/http'), require('@auth0/angular-jwt'), require('rxjs'), require('@angular/platform-browser/animations'), require('@angular/material/list'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('@cleavelandprice/ngx-lib', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@angular/material/button', '@angular/material/checkbox', '@angular/material/dialog', '@angular/material/input', '@angular/material/progress-bar', '@angular/material/progress-spinner', '@angular/material/select', '@angular/material/tooltip', '@angular/common/http', '@auth0/angular-jwt', 'rxjs', '@angular/platform-browser/animations', '@angular/material/list', '@angular/platform-browser'], factory) :
    (global = global || self, factory((global.cleavelandprice = global.cleavelandprice || {}, global.cleavelandprice['ngx-lib'] = {}), global.ng.core, global.ng.common, global.ng.forms, global.ng.material.button, global.ng.material.checkbox, global.ng.material.dialog, global.ng.material.input, global.ng.material['progress-bar'], global.ng.material['progress-spinner'], global.ng.material.select, global.ng.material.tooltip, global.ng.common.http, global.angularJwt, global.rxjs, global.ng.platformBrowser.animations, global.ng.material.list, global.ng.platformBrowser));
}(this, (function (exports, core, common, forms, button, checkbox, dialog, input, progressBar, progressSpinner, select, tooltip, http, angularJwt, rxjs, animations, list, platformBrowser) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    (function (ConfirmationDialogMode) {
        ConfirmationDialogMode[ConfirmationDialogMode["OkCancel"] = 0] = "OkCancel";
        ConfirmationDialogMode[ConfirmationDialogMode["YesNo"] = 1] = "YesNo";
        ConfirmationDialogMode[ConfirmationDialogMode["TrueFalse"] = 2] = "TrueFalse";
        ConfirmationDialogMode[ConfirmationDialogMode["Custom"] = 3] = "Custom";
    })(exports.ConfirmationDialogMode || (exports.ConfirmationDialogMode = {}));

    var DialogComponent = /** @class */ (function () {
        function DialogComponent() {
            this.closed = new core.EventEmitter();
            this.ConfirmationDialogMode = exports.ConfirmationDialogMode;
            this.mode = exports.ConfirmationDialogMode.OkCancel;
            this.customTrueFalseText = null;
        }
        DialogComponent.prototype.ngOnInit = function () {
            if (this.data) {
                this.title = this.data.title || null;
                this.message = this.data.message || null;
                this.checkboxMessage = this.data.checkboxMessage || null;
                this.placeholder = this.data.placeholder || null;
                this.userInput = this.data.value || null;
                this.mode = this.data.mode || exports.ConfirmationDialogMode.OkCancel;
                this.customTrueFalseText = this.data.customTrueFalseText;
            }
        };
        DialogComponent.prototype.close = function () {
            var data;
            switch (this.dialogType) {
                case 'message':
                    data = this.checkboxMessage ?
                        {
                            checkbox: this.checkboxValue || false
                        } :
                        null;
                    break;
                case 'input':
                    data = this.checkboxMessage ?
                        {
                            response: this.userInput,
                            checkbox: this.checkboxValue || false
                        } :
                        this.userInput;
                    break;
                case 'confirmation':
                    data = this.checkboxMessage ?
                        {
                            response: true,
                            checkbox: this.checkboxValue || false
                        } :
                        true;
                    break;
            }
            this.closed.emit(data);
        };
        DialogComponent.prototype.cancel = function () {
            var data;
            if (this.dialogType === 'confirmation') {
                data = this.checkboxMessage ?
                    {
                        response: false,
                        checkbox: this.checkboxValue || false
                    } :
                    false;
            }
            this.closed.emit(data);
        };
        __decorate([
            core.Input()
        ], DialogComponent.prototype, "dialogType", void 0);
        __decorate([
            core.Input()
        ], DialogComponent.prototype, "data", void 0);
        __decorate([
            core.Output()
        ], DialogComponent.prototype, "closed", void 0);
        DialogComponent = __decorate([
            core.Component({
                selector: 'cp-dialog',
                template: "<h2 *ngIf=\"title\" mat-dialog-title [innerHTML]=\"title\"></h2>\r\n\r\n<mat-dialog-content>\r\n    <div *ngIf=\"message\" [innerHTML]=\"message\"></div>\r\n\r\n    <mat-form-field *ngIf=\"dialogType === 'input'\">\r\n        <textarea matInput [placeholder]=\"placeholder\" [(ngModel)]=\"userInput\"></textarea>\r\n    </mat-form-field>\r\n\r\n    <div id=\"checkbox\" *ngIf=\"checkboxMessage\">\r\n        <mat-checkbox [(ngModel)]=\"checkboxValue\">\r\n            <span [innerHTML]=\"checkboxMessage\"></span>\r\n        </mat-checkbox>\r\n    </div>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions>\r\n    <button mat-raised-button (click)=\"close()\" [disabled]=\"dialogType === 'input' && !userInput\">\r\n        <span [ngSwitch]=\"mode\">\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">Yes</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">True</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[0] }}</span>\r\n            <span *ngSwitchDefault>OK</span>\r\n        </span>\r\n    </button>\r\n    <button *ngIf=\"dialogType !== 'message'\" mat-raised-button (click)=\"cancel()\">\r\n        <span [ngSwitch]=\"mode\">\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.YesNo\">No</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.TrueFalse\">False</span>\r\n            <span *ngSwitchCase=\"ConfirmationDialogMode.Custom\">{{ customTrueFalseText[1] }}</span>\r\n            <span *ngSwitchDefault>Cancel</span>\r\n        </span>\r\n    </button>\r\n</mat-dialog-actions>",
                styles: ["mat-form-field{margin-top:2em;width:100%}#checkbox{margin:2em 0}"]
            })
        ], DialogComponent);
        return DialogComponent;
    }());

    var ConfirmationDialogComponent = /** @class */ (function () {
        function ConfirmationDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        ConfirmationDialogComponent.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
        ]; };
        ConfirmationDialogComponent = __decorate([
            core.Component({
                selector: 'cp-confirmation-dialog',
                template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'confirmation'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>"
            }),
            __param(1, core.Inject(dialog.MAT_DIALOG_DATA))
        ], ConfirmationDialogComponent);
        return ConfirmationDialogComponent;
    }());

    var InputDialogComponent = /** @class */ (function () {
        function InputDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        InputDialogComponent.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
        ]; };
        InputDialogComponent = __decorate([
            core.Component({
                selector: 'cp-input-dialog',
                template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'input'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>"
            }),
            __param(1, core.Inject(dialog.MAT_DIALOG_DATA))
        ], InputDialogComponent);
        return InputDialogComponent;
    }());

    var MessageDialogComponent = /** @class */ (function () {
        function MessageDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        MessageDialogComponent.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
        ]; };
        MessageDialogComponent = __decorate([
            core.Component({
                selector: 'cp-message-dialog',
                template: "<cp-dialog\r\n  [data]=\"data\"\r\n  [dialogType]=\"'message'\"\r\n  (closed)=\"dialogRef.close($event)\">\r\n</cp-dialog>"
            }),
            __param(1, core.Inject(dialog.MAT_DIALOG_DATA))
        ], MessageDialogComponent);
        return MessageDialogComponent;
    }());

    //#endregion
    var DialogModule = /** @class */ (function () {
        function DialogModule() {
        }
        DialogModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    button.MatButtonModule,
                    checkbox.MatCheckboxModule,
                    input.MatInputModule,
                    dialog.MatDialogModule
                ],
                declarations: [
                    DialogComponent,
                    ConfirmationDialogComponent,
                    InputDialogComponent,
                    MessageDialogComponent
                ],
                exports: [
                    ConfirmationDialogComponent,
                    InputDialogComponent,
                    MessageDialogComponent
                ],
                entryComponents: [
                    ConfirmationDialogComponent,
                    InputDialogComponent,
                    MessageDialogComponent
                ]
            })
        ], DialogModule);
        return DialogModule;
    }());

    var AuthenticationServiceConfig = /** @class */ (function () {
        function AuthenticationServiceConfig() {
        }
        return AuthenticationServiceConfig;
    }());

    var SharePointServiceConfig = /** @class */ (function () {
        function SharePointServiceConfig() {
        }
        return SharePointServiceConfig;
    }());

    //#endregion
    var SharePointService = /** @class */ (function () {
        //#endregion
        function SharePointService(config, http) {
            this.config = config;
            this.http = http;
        }
        //#region Utilities
        SharePointService.prototype.getListItems = function (list) {
            return this.http.post(this.config.sharePointApiUrl, list);
        };
        SharePointService.prototype.getListItemsSimple = function (list, view, site, limit) {
            return this.http.get(this.config.sharePointApiUrl + "/" + list + "/" + view + "/" + site + "/" + limit);
        };
        SharePointService.prototype.getPeople = function (storePeople) {
            var _this = this;
            // Do we already have people stored locally?
            if (this.people) {
                return rxjs.of(this.people);
                // return Observable.of(this.people);
            }
            // Should we store people locally for subsequent calls?
            if (storePeople) {
                this.http.get(this.config.sharePointApiUrl + "/people")
                    .subscribe(function (peeps) { return _this.people = peeps; });
            }
            return this.http.get(this.config.sharePointApiUrl + "/people");
        };
        SharePointService.prototype.getPhotos = function (storePhotos) {
            var _this = this;
            // Do we already have photos stored locally?
            if (this.photos) {
                return rxjs.of(this.photos);
                // return Observable.of(this.photos);
            }
            var spList = {
                list: 'Employee Thumbnail Photos',
                view: 'All Pictures',
                site: 'http://cpsp1/DigitalDisplay',
                userName: this.config.userName,
                password: this.config.password
            };
            // Should we store photos locally for subsequent calls?
            if (storePhotos) {
                this.http.post(this.config.sharePointApiUrl, spList)
                    .subscribe(function (photos) { return _this.photos = photos; });
            }
            return this.http.post(this.config.sharePointApiUrl, spList);
        };
        SharePointService.prototype.getCustomerVisits = function () {
            var list = {
                list: 'Customer Visits',
                view: 'All Events',
                userName: this.config.userName,
                password: this.config.password
            };
            return this.http.post(this.config.sharePointApiUrl, list);
        };
        SharePointService.ctorParameters = function () { return [
            { type: SharePointServiceConfig, decorators: [{ type: core.Optional }] },
            { type: http.HttpClient }
        ]; };
        SharePointService = __decorate([
            core.Injectable(),
            __param(0, core.Optional())
        ], SharePointService);
        return SharePointService;
    }());

    //#endregion
    /**
     * Authenticate Active Directory user
     */
    var AuthenticationService = /** @class */ (function () {
        //#endregion
        //#region Lifecycle
        /**
         * @ignore
         */
        function AuthenticationService(config, http, sharePointService) {
            this.http = http;
            this.sharePointService = sharePointService;
            this.authenticatedChanged = new core.EventEmitter();
            this.authenticatingChanged = new core.EventEmitter();
            /**
             * Flag set to true while the service is attempting to authenticate the user
             */
            this.authenticating = false;
            /**
             * Flag set to true when the user is successfully authenticated
             */
            this.authenticated = false;
            this.authenticationApiUrl = config.authenticationApiUrl;
            this.checkForExistingToken();
        }
        //#endregion
        //#region Utilities
        /**
         * Authenticate the user and store the token in Local Storage
         *
         * @param username AD sAMAccountName
         * @param password
         * @param adminGroup AD group that determines if authenticated user is considered an administrator of the app
         */
        AuthenticationService.prototype.login = function (username, password, adminGroup) {
            var _this = this;
            var today = new Date();
            var expiration = new Date().setFullYear(today.getFullYear() + 10);
            var request = {
                username: username,
                password: password,
                adminGroup: adminGroup,
                expirationDate: expiration // moment().add(10, 'years').toDate()
            };
            this.authenticating = true;
            this.authenticatingChanged.emit(this.authenticating);
            this.http.post(this.authenticationApiUrl, request)
                .subscribe(function (token) { return _this.validateUser(token); }, function (err) {
                _this.authenticating = false;
                _this.authenticatingChanged.emit(_this.authenticating);
            });
        };
        /**
         * Logout the user and delete the token from Local Storage
         */
        AuthenticationService.prototype.logout = function () {
            if (localStorage.getItem('token')) {
                localStorage.removeItem('token');
            }
            this.authenticatedUser = null;
            this.authenticated = false;
            this.authenticatedChanged.emit(false);
        };
        /**
         * @ignore
         */
        AuthenticationService.prototype.validateUser = function (token) {
            if (!token) {
                return;
            }
            var jwtHelper = new angularJwt.JwtHelperService();
            var decoded = jwtHelper.decodeToken(token);
            if (jwtHelper.isTokenExpired(token)) {
                this.logout();
                return;
            }
            this.authenticatedUser = {
                admin: decoded.role === 'Admin',
                displayName: decoded.displayName,
                accountName: decoded.winaccountname,
                distinguishedName: decoded.distinguishedName,
                employeeNumber: decoded.employeeNumber,
                memberOf: decoded.memberOf
            };
            localStorage.setItem('token', token);
            this.getPhoto();
            this.authenticated = true;
            this.authenticatedChanged.emit(this.authenticated);
            this.authenticating = false;
            this.authenticatingChanged.emit(this.authenticating);
        };
        /**
         * @ignore
         */
        AuthenticationService.prototype.getPhoto = function () {
            var _this = this;
            this.sharePointService.getPhotos()
                .subscribe(function (photos) {
                // The user may have been logged out by the time the photos came back
                if (!_this.authenticatedUser || !_this.authenticatedUser.employeeNumber) {
                    return;
                }
                var photo = photos.find(function (pic) { return +pic.ows_EmployeeNumber === +_this.authenticatedUser.employeeNumber; });
                if (photo) {
                    _this.authenticatedUser.photoUrl = photo.ows_EncodedAbsUrl;
                }
            });
        };
        /**
         * @ignore
         */
        AuthenticationService.prototype.checkForExistingToken = function () {
            if (localStorage.getItem('token')) {
                this.validateUser(localStorage.getItem('token'));
            }
        };
        AuthenticationService.ctorParameters = function () { return [
            { type: AuthenticationServiceConfig, decorators: [{ type: core.Optional }] },
            { type: http.HttpClient },
            { type: SharePointService }
        ]; };
        __decorate([
            core.Output()
        ], AuthenticationService.prototype, "authenticatedChanged", void 0);
        __decorate([
            core.Output()
        ], AuthenticationService.prototype, "authenticatingChanged", void 0);
        AuthenticationService = __decorate([
            core.Injectable(),
            __param(0, core.Optional())
        ], AuthenticationService);
        return AuthenticationService;
    }());

    var LoginFormComponent = /** @class */ (function () {
        function LoginFormComponent(dialogRef, sharePointService, authenticationService, data) {
            this.dialogRef = dialogRef;
            this.sharePointService = sharePointService;
            this.authenticationService = authenticationService;
            this.data = data;
            this.adminGroup = data.adminGroup;
        }
        LoginFormComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.authenticationService.authenticatedChanged
                .subscribe(function (authenticated) {
                if (authenticated) {
                    _this.dialogRef.close();
                }
            });
        };
        LoginFormComponent.prototype.authenticate = function () {
            if (!this.sharePointService || !this.username || !this.password) {
                return;
            }
            this.authenticationService.login(this.username, this.password, this.adminGroup);
        };
        LoginFormComponent.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: SharePointService },
            { type: AuthenticationService },
            { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
        ]; };
        LoginFormComponent = __decorate([
            core.Component({
                selector: 'cp-login-form',
                template: "<h2 mat-dialog-title>\n  <span *ngIf=\"!authenticationService.authenticating\">Login</span>\n  <span *ngIf=\"authenticationService.authenticating\">Authenticating...</span>\n</h2>\n\n<mat-dialog-content [class.loginError]=\"loginError\">\n  <div id=\"spinner\" *ngIf=\"authenticationService.authenticating\">\n    <mat-progress-spinner color=\"primary\" mode=\"indeterminate\"></mat-progress-spinner>\n  </div>\n\n  <div *ngIf=\"!authenticationService.authenticating\">\n    <div>\n      <mat-form-field>\n        <input matInput placeholder=\"Username\" [(ngModel)]=\"username\" name=\"username\" required (keyup.enter)=\"authenticate()\">\n      </mat-form-field>\n    </div>\n\n    <div>\n      <mat-form-field>\n        <input matInput type=\"password\" placeholder=\"Password\" [(ngModel)]=\"password\" name=\"password\" required (keyup.enter)=\"authenticate()\">\n      </mat-form-field>\n    </div>\n  </div>\n\n  <div *ngIf=\"!authenticationService.authenticating && loginError\" class=\"alert alert-danger\">\n    Bad username or password\n  </div>\n</mat-dialog-content>\n\n<mat-dialog-actions *ngIf=\"!authenticationService.authenticating\">\n  <button type=\"button\" mat-raised-button (click)=\"authenticate()\">OK</button>\n  <button type=\"button\" mat-button (click)=\"dialogRef.close()\">Cancel</button>\n</mat-dialog-actions>",
                styles: ["#spinner{width:100%;height:100%;display:flex;justify-content:center;align-items:center}mat-dialog-content{height:150px}mat-dialog-content.loginError{height:200px}"]
            }),
            __param(3, core.Inject(dialog.MAT_DIALOG_DATA))
        ], LoginFormComponent);
        return LoginFormComponent;
    }());

    var LoginComponent = /** @class */ (function () {
        function LoginComponent(dialog, authenticationService) {
            this.dialog = dialog;
            this.authenticationService = authenticationService;
        }
        LoginComponent.prototype.ngOnInit = function () {
        };
        LoginComponent.prototype.login = function () {
            this.dialog.open(LoginFormComponent, {
                data: { adminGroup: this.adminGroup }
            });
        };
        LoginComponent.prototype.confirmLogout = function () {
            var _this = this;
            var dialogRef = this.dialog.open(ConfirmationDialogComponent, {
                data: { message: "Are you sure you want to logout?" }
            });
            dialogRef.afterClosed().subscribe(function (result) {
                if (result) {
                    _this.authenticationService.logout();
                }
            });
        };
        LoginComponent.ctorParameters = function () { return [
            { type: dialog.MatDialog },
            { type: AuthenticationService }
        ]; };
        __decorate([
            core.Input()
        ], LoginComponent.prototype, "adminGroup", void 0);
        LoginComponent = __decorate([
            core.Component({
                selector: 'cp-login',
                template: "<div id=\"user-id\">\n  <i id=\"unauthenticated-user-image\" *ngIf=\"!authenticationService.authenticated\"\n    class=\"fa fa-user-circle\"\n    [class.fa-spin]=\"authenticationService.authenticating\"\n    aria-hidden=\"true\"\n    matTooltip=\"Login\"\n    (click)=\"login()\"></i>\n\n  <img id=\"authenticated-user-image\"\n    *ngIf=\"authenticationService.authenticated && authenticationService.authenticatedUser.photoUrl\"\n    [src]=\"authenticationService.authenticatedUser.photoUrl\"\n    matTooltip=\"Logout\"\n    (click)=\"confirmLogout()\" />\n\n  <i id=\"authenticated-user-image\"\n    *ngIf=\"authenticationService.authenticated && !authenticationService.authenticatedUser.photoUrl\"\n    class=\"fa fa-user-circle\"\n    matTooltip=\"Logout\"\n    (click)=\"confirmLogout()\"></i>\n\n  <div id=\"user-name\" *ngIf=\"authenticationService.authenticated\">\n    {{ authenticationService.authenticatedUser.displayName }}\n  </div>\n</div>",
                styles: ["#user-id{display:flex;height:2em;padding:.3em;font-family:Verdana,Geneva,Tahoma,sans-serif}.fa{font-size:2em}img{border-radius:100%;width:2em;height:2em}#user-id>div{display:flex;align-items:center;height:100%;margin-left:.75em;font-size:1.15em}"]
            })
        ], LoginComponent);
        return LoginComponent;
    }());

    //#endregion
    /**
     * Provides a component and a service that allows you to perform Active/Directory authentication
     */
    var AuthenticationModule = /** @class */ (function () {
        function AuthenticationModule(parentModule) {
            if (parentModule) {
                throw new Error('AuthenticationModule is already loaded. Import it in the AppModule only');
            }
        }
        AuthenticationModule_1 = AuthenticationModule;
        AuthenticationModule.forRoot = function (authenticationConfig) {
            return {
                ngModule: AuthenticationModule_1,
                providers: [
                    AuthenticationService,
                    { provide: AuthenticationServiceConfig, useValue: authenticationConfig }
                ]
            };
        };
        var AuthenticationModule_1;
        AuthenticationModule.ctorParameters = function () { return [
            { type: AuthenticationModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        AuthenticationModule = AuthenticationModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    button.MatButtonModule,
                    checkbox.MatCheckboxModule,
                    dialog.MatDialogModule,
                    input.MatInputModule,
                    progressBar.MatProgressBarModule,
                    progressSpinner.MatProgressSpinnerModule,
                    tooltip.MatTooltipModule,
                    select.MatSelectModule,
                    DialogModule
                ],
                declarations: [
                    LoginComponent,
                    LoginFormComponent
                ],
                exports: [
                    LoginComponent,
                    LoginFormComponent
                ],
                providers: [],
                entryComponents: [
                    LoginFormComponent
                ]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf())
        ], AuthenticationModule);
        return AuthenticationModule;
    }());

    var EmailServiceConfig = /** @class */ (function () {
        function EmailServiceConfig() {
        }
        return EmailServiceConfig;
    }());

    //#endregion
    var EmailService = /** @class */ (function () {
        function EmailService(config, http) {
            this.http = http;
            this.emailServiceConfig = config;
        }
        EmailService.prototype.send = function (email) {
            var dto = {
                server: this.emailServiceConfig.server,
                smtpPort: this.emailServiceConfig.smtpPort,
                sender: this.emailServiceConfig.sender,
                subject: email.subject,
                content: email.content,
                recipients: email.recipients
            };
            return this.http.post(this.emailServiceConfig.emailApiUrl, dto);
        };
        EmailService.ctorParameters = function () { return [
            { type: EmailServiceConfig, decorators: [{ type: core.Optional }] },
            { type: http.HttpClient }
        ]; };
        EmailService = __decorate([
            core.Injectable(),
            __param(0, core.Optional())
        ], EmailService);
        return EmailService;
    }());

    //#endregion
    var EmailModule = /** @class */ (function () {
        function EmailModule(parentModule) {
            if (parentModule) {
                throw new Error('EmailModule is already loaded. Import it in the AppModule only');
            }
        }
        EmailModule_1 = EmailModule;
        EmailModule.forRoot = function (emailConfig) {
            return {
                ngModule: EmailModule_1,
                providers: [
                    EmailService,
                    { provide: EmailServiceConfig, useValue: emailConfig }
                ]
            };
        };
        var EmailModule_1;
        EmailModule.ctorParameters = function () { return [
            { type: EmailModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        EmailModule = EmailModule_1 = __decorate([
            core.NgModule({
                imports: [common.CommonModule],
                declarations: [],
                exports: []
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf())
        ], EmailModule);
        return EmailModule;
    }());

    var EmployeeServiceConfig = /** @class */ (function () {
        function EmployeeServiceConfig() {
        }
        return EmployeeServiceConfig;
    }());

    //#endregion
    var EmployeeService = /** @class */ (function () {
        //#endregion
        //#region Lifecycle
        function EmployeeService(config, http) {
            this.http = http;
            this.employeeApiUrl = config.employeeApiUrl;
        }
        //#endregion
        //#region Utilities
        EmployeeService.prototype.getEmployees = function (storeEmployees, includeDisabled) {
            var _this = this;
            if (storeEmployees === void 0) { storeEmployees = false; }
            if (includeDisabled === void 0) { includeDisabled = false; }
            // Do we already have employees stored locally?
            if (this.employees) {
                return rxjs.of(this.employees);
                // return Observable.of(this.employees);
            }
            // Should we store employees locally for subsequent calls?
            if (storeEmployees) {
                this.http.get(this.employeeApiUrl + "/false/" + includeDisabled)
                    .subscribe(function (emps) { return _this.employees = emps; });
            }
            return this.http.get(this.employeeApiUrl + "/false/" + includeDisabled);
        };
        EmployeeService.prototype.getEmployee = function (sAMAccountName) {
            return this.http.get(this.employeeApiUrl + "/name/" + sAMAccountName);
        };
        EmployeeService.ctorParameters = function () { return [
            { type: EmployeeServiceConfig, decorators: [{ type: core.Optional }] },
            { type: http.HttpClient }
        ]; };
        EmployeeService = __decorate([
            core.Injectable(),
            __param(0, core.Optional())
        ], EmployeeService);
        return EmployeeService;
    }());

    var DepartmentsPipe = /** @class */ (function () {
        function DepartmentsPipe() {
        }
        DepartmentsPipe.prototype.transform = function (employees, args) {
            var departments = [];
            employees
                .filter(function (emp) { return emp.department; })
                .forEach(function (emp) {
                if (departments.indexOf(emp.department) === -1) {
                    departments.push(emp.department);
                }
            });
            return departments.sort();
        };
        DepartmentsPipe = __decorate([
            core.Pipe({
                name: 'departments'
            })
        ], DepartmentsPipe);
        return DepartmentsPipe;
    }());

    var EmployeeByDnPipe = /** @class */ (function () {
        function EmployeeByDnPipe() {
        }
        EmployeeByDnPipe.prototype.transform = function (employees, dn) {
            return employees
                .find(function (emp) { return emp.distinguishedName.toLowerCase() === dn.toLowerCase(); });
        };
        EmployeeByDnPipe = __decorate([
            core.Pipe({
                name: 'employeeByDn'
            })
        ], EmployeeByDnPipe);
        return EmployeeByDnPipe;
    }());

    var EmployeePhotoUrlPipe = /** @class */ (function () {
        function EmployeePhotoUrlPipe() {
        }
        EmployeePhotoUrlPipe.prototype.transform = function (employee, photos) {
            if (!photos) {
                return null;
            }
            // Try to match by employeeNumber, accountName, or title
            var photo = photos
                .find(function (pic) {
                return (pic.ows_EmployeeNumber && employee.employeeNumber && +pic.ows_EmployeeNumber === +employee.employeeNumber) ||
                    (pic.ows_AccountName && pic.ows_AccountName.toLowerCase() === employee.sAMAccountName.toLowerCase()) ||
                    (pic.ows_Title && pic.ows_Title.toLowerCase() === employee.displayName.toLowerCase());
            });
            if (!photo) {
                console.log("No photo match for " + employee.displayName);
            }
            return photo ? photo.ows_EncodedAbsUrl : null;
        };
        EmployeePhotoUrlPipe = __decorate([
            core.Pipe({
                name: 'employeePhotoUrl'
            })
        ], EmployeePhotoUrlPipe);
        return EmployeePhotoUrlPipe;
    }());

    var EmployeesWithPropertyValuePipe = /** @class */ (function () {
        function EmployeesWithPropertyValuePipe() {
        }
        EmployeesWithPropertyValuePipe.prototype.transform = function (employees, propertyName, propertyValue) {
            return employees
                .filter(function (emp) { return emp[propertyName] && emp[propertyName] === propertyValue; });
        };
        EmployeesWithPropertyValuePipe = __decorate([
            core.Pipe({
                name: 'employeesWithPropertyValue'
            })
        ], EmployeesWithPropertyValuePipe);
        return EmployeesWithPropertyValuePipe;
    }());

    var FilterEmployeesPipe = /** @class */ (function () {
        function FilterEmployeesPipe() {
        }
        FilterEmployeesPipe.prototype.transform = function (employees, filter) {
            return filter ?
                employees
                    .filter(function (emp) {
                    return emp.displayName.toLowerCase().indexOf(filter.toLowerCase()) !== -1 ||
                        (emp.department && emp.department.toLowerCase().indexOf(filter.toLowerCase()) !== -1) ||
                        (emp.title && emp.title.toLowerCase().indexOf(filter.toLowerCase()) !== -1) ||
                        emp.sAMAccountName.toLowerCase().indexOf(filter.toLowerCase()) !== -1;
                }) :
                employees;
        };
        FilterEmployeesPipe = __decorate([
            core.Pipe({
                name: 'filterEmployees'
            })
        ], FilterEmployeesPipe);
        return FilterEmployeesPipe;
    }());

    var IsMemberOfPipe = /** @class */ (function () {
        function IsMemberOfPipe() {
        }
        IsMemberOfPipe.prototype.transform = function (employee, groupName) {
            return employee.memberOf &&
                (employee.memberOf.find(function (m) { return m.toLowerCase().indexOf(groupName.toLowerCase()) !== -1; }) !== undefined);
        };
        IsMemberOfPipe = __decorate([
            core.Pipe({
                name: 'isMemberOf'
            })
        ], IsMemberOfPipe);
        return IsMemberOfPipe;
    }());

    var SortEmployeesPipe = /** @class */ (function () {
        function SortEmployeesPipe() {
        }
        SortEmployeesPipe.prototype.transform = function (employees, sortBy, dataType, reverse) {
            return this.getSorted(employees, sortBy ? sortBy : 'displayName', dataType ? dataType : 'string', reverse ? reverse : false);
        };
        SortEmployeesPipe.prototype.getSorted = function (employees, sortBy, dataType, reverse) {
            var sorted = employees
                .sort(function (a, b) {
                var valA, valB;
                switch (dataType.toLowerCase()) {
                    case 'string':
                        valA = a[sortBy] ? a[sortBy].toString().toLowerCase() : null;
                        valB = b[sortBy] ? b[sortBy].toString().toLowerCase() : null;
                        break;
                    case 'number':
                        valA = a[sortBy] ? +a[sortBy] : null;
                        valB = b[sortBy] ? +b[sortBy] : null;
                        break;
                    case 'date':
                        valA = a[sortBy] ? a[sortBy] : null;
                        valB = b[sortBy] ? b[sortBy] : null;
                        break;
                }
                if (valA < valB) {
                    return -1;
                }
                if (valA > valB) {
                    return 1;
                }
                return 0;
            });
            return reverse ? sorted.reverse() : sorted;
        };
        SortEmployeesPipe = __decorate([
            core.Pipe({
                name: 'sortEmployees'
            })
        ], SortEmployeesPipe);
        return SortEmployeesPipe;
    }());

    //#endregion
    var EmployeeModule = /** @class */ (function () {
        function EmployeeModule(parentModule) {
            if (parentModule) {
                throw new Error('EmployeeModule is already loaded. Import it in the AppModule only');
            }
        }
        EmployeeModule_1 = EmployeeModule;
        EmployeeModule.forRoot = function (employeeConfig) {
            return {
                ngModule: EmployeeModule_1,
                providers: [
                    EmployeeService,
                    { provide: EmployeeServiceConfig, useValue: employeeConfig }
                ]
            };
        };
        var EmployeeModule_1;
        EmployeeModule.ctorParameters = function () { return [
            { type: EmployeeModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        EmployeeModule = EmployeeModule_1 = __decorate([
            core.NgModule({
                imports: [common.CommonModule],
                declarations: [
                    DepartmentsPipe,
                    EmployeeByDnPipe,
                    EmployeesWithPropertyValuePipe,
                    FilterEmployeesPipe,
                    IsMemberOfPipe,
                    EmployeePhotoUrlPipe,
                    SortEmployeesPipe
                ],
                exports: [
                    DepartmentsPipe,
                    EmployeeByDnPipe,
                    EmployeesWithPropertyValuePipe,
                    FilterEmployeesPipe,
                    IsMemberOfPipe,
                    EmployeePhotoUrlPipe,
                    SortEmployeesPipe
                ]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf())
        ], EmployeeModule);
        return EmployeeModule;
    }());

    var SharePointPhotoUrlPipe = /** @class */ (function () {
        function SharePointPhotoUrlPipe() {
        }
        SharePointPhotoUrlPipe.prototype.transform = function (photo) {
            return photo.ows_EncodedAbsUrl;
        };
        SharePointPhotoUrlPipe = __decorate([
            core.Pipe({
                name: 'sharePointPhotoUrl'
            })
        ], SharePointPhotoUrlPipe);
        return SharePointPhotoUrlPipe;
    }());

    var SharePointUrlPipe = /** @class */ (function () {
        function SharePointUrlPipe() {
        }
        SharePointUrlPipe.prototype.transform = function (url) {
            return url !== null ? url.split(',')[0] : null;
        };
        SharePointUrlPipe = __decorate([
            core.Pipe({
                name: 'sharePointUrl'
            })
        ], SharePointUrlPipe);
        return SharePointUrlPipe;
    }());

    //#endregion
    var SharePointModule = /** @class */ (function () {
        function SharePointModule(parentModule) {
            if (parentModule) {
                throw new Error('SharePointModule is already loaded. Import it in the AppModule only');
            }
        }
        SharePointModule_1 = SharePointModule;
        SharePointModule.forRoot = function (sharePointConfig) {
            return {
                ngModule: SharePointModule_1,
                providers: [
                    SharePointService,
                    { provide: SharePointServiceConfig, useValue: sharePointConfig }
                ]
            };
        };
        var SharePointModule_1;
        SharePointModule.ctorParameters = function () { return [
            { type: SharePointModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        SharePointModule = SharePointModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    SharePointPhotoUrlPipe,
                    SharePointUrlPipe
                ],
                exports: [
                    SharePointPhotoUrlPipe,
                    SharePointUrlPipe
                ]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf())
        ], SharePointModule);
        return SharePointModule;
    }());

    var UploadServiceConfig = /** @class */ (function () {
        function UploadServiceConfig() {
        }
        return UploadServiceConfig;
    }());

    // https://malcoded.com/posts/angular-file-upload-component-with-express
    var UploadService = /** @class */ (function () {
        function UploadService(http, config) {
            this.http = http;
            this.uploadApiUrl = config.uploadApiUrl;
            this.uploadPath = config.uploadPath || '';
            this.dbAppId = config.dbAppId || '';
            this.externalReferenceId = config.externalReferenceId || '';
            this.comment = config.comment || '';
            // UI configuration
            this.uploadButtonText = config.uploadButtonText;
            this.uploadDialogTitle = config.uploadDialogTitle;
            this.uploadDialogAddFilesButtonText = config.uploadDialogAddFilesButtonText;
            this.uploadDialogCancelButtonText = config.uploadDialogCancelButtonText;
            this.uploadDialogUploadButtonText = config.uploadDialogUploadButtonText;
            this.uploadDialogFinishButtonText = config.uploadDialogFinishButtonText;
        }
        UploadService.prototype.upload = function (files) {
            var _this = this;
            // this will be the our resulting map
            var status = {};
            files.forEach(function (file) {
                // create a new multipart-form for every file
                var formData = new FormData();
                formData.append('file', file, file.name);
                // create a http-post request and pass the form
                // tell it to report the upload progress
                // A 'Destination' header is used to optionally configure the file upload destination (filesystem)
                // A 'DbAppId' header is used to configure the unique identifier of database uploads
                var req = new http.HttpRequest('POST', _this.uploadApiUrl, formData, {
                    reportProgress: true,
                    responseType: 'blob',
                    headers: new http.HttpHeaders()
                        .set('Destination', _this.uploadPath)
                        .set('DbAppId', _this.dbAppId)
                        .set('ExternalReferenceId', _this.externalReferenceId)
                        .set('Comment', _this.comment)
                    /*headers: this.uploadPath ?
                      new HttpHeaders({ 'Destination': this.uploadPath }) :
                      this.dbAppId ?
                        new HttpHeaders({ 'DbAppId': this.dbAppId }) :
                        null*/
                });
                // create a new progress-subject for every file
                var progress = new rxjs.Subject();
                // send the http-request and subscribe for progress-updates
                _this.http.request(req).subscribe(function (event) {
                    if (event.type === http.HttpEventType.UploadProgress) {
                        // calculate the progress percentage
                        var percentDone = Math.round(100 * event.loaded / event.total);
                        // pass the percentage into the progress-stream
                        progress.next(percentDone);
                    }
                    else if (event instanceof http.HttpResponse) {
                        // Close the progress-stream if we get an answer form the API
                        // The upload is complete
                        progress.complete();
                    }
                });
                // Save every progress-observable in a map of all observables
                status[file.name] = {
                    progress: progress.asObservable()
                };
            });
            // return the map of progress.observables
            return status;
        };
        UploadService.prototype.exists = function (fileName) {
            var query = this.uploadApiUrl.toLowerCase().indexOf('filesystem') === -1 ?
                { name: fileName, dbAppId: this.dbAppId } :
                { name: fileName, destination: this.uploadPath };
            return this.http.post(this.uploadApiUrl + "/exists", query);
        };
        UploadService.prototype.download = function (request) {
            return this.http.post(this.uploadApiUrl + "/stream", request, { responseType: 'blob' });
        };
        UploadService.prototype.getUploadInfo = function (request) {
            return this.http.post(this.uploadApiUrl + "/info", request);
        };
        UploadService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: UploadServiceConfig, decorators: [{ type: core.Optional }] }
        ]; };
        UploadService = __decorate([
            core.Injectable(),
            __param(1, core.Optional())
        ], UploadService);
        return UploadService;
    }());

    var UploadDialogComponent = /** @class */ (function () {
        function UploadDialogComponent(dialogRef, uploadService) {
            this.dialogRef = dialogRef;
            this.uploadService = uploadService;
            this.files = new Set();
            this.canBeClosed = true;
            this.showCancelButton = true;
            this.uploading = false;
            this.uploadSuccessful = false;
        }
        UploadDialogComponent.prototype.ngOnInit = function () {
            this.uploadDialogTitle = this.uploadService.uploadDialogTitle ?
                this.uploadService.uploadDialogTitle :
                'Upload Files';
            this.uploadDialogAddFilesButtonText = this.uploadService.uploadDialogAddFilesButtonText ?
                this.uploadService.uploadDialogAddFilesButtonText :
                'Add Files';
            this.uploadDialogCancelButtonText = this.uploadService.uploadDialogCancelButtonText ?
                this.uploadService.uploadDialogCancelButtonText :
                'Cancel';
            this.uploadDialogUploadButtonText = this.uploadService.uploadDialogUploadButtonText ?
                this.uploadService.uploadDialogUploadButtonText :
                'Upload';
            this.uploadDialogFinishButtonText = this.uploadService.uploadDialogFinishButtonText ?
                this.uploadService.uploadDialogFinishButtonText :
                'Finish';
            this.primaryButtonText = this.uploadDialogUploadButtonText;
        };
        UploadDialogComponent.prototype.addFiles = function () {
            this.file.nativeElement.click();
        };
        UploadDialogComponent.prototype.onFilesAdded = function () {
            var _this = this;
            var files = this.file.nativeElement.files;
            var _loop_1 = function (key) {
                if (!isNaN(parseInt(key))) {
                    // See if the file already exists
                    this_1.uploadService.exists(files[key].name)
                        .subscribe(function (exists) {
                        if (exists) {
                            _this.existingFileConflict = files[key].name;
                        }
                        if (!exists) {
                            _this.files.add(files[key]);
                        }
                    });
                }
            };
            var this_1 = this;
            for (var key in files) {
                _loop_1(key);
            }
        };
        UploadDialogComponent.prototype.closeDialog = function () {
            var _this = this;
            // if everything was uploaded already, just close the dialog
            if (this.uploadSuccessful) {
                return this.dialogRef.close();
            }
            // set the component state to "uploading"
            this.uploading = true;
            // start the upload and save the progress map
            this.progress = this.uploadService.upload(this.files);
            // convert the progress map into an array
            var allProgressObservables = [];
            for (var key in this.progress) {
                allProgressObservables.push(this.progress[key].progress);
            }
            // Adjust the state variables
            // The OK-button should have the text "Finish" now
            this.primaryButtonText = this.uploadDialogFinishButtonText;
            // The dialog should not be closed while uploading
            this.canBeClosed = false;
            this.dialogRef.disableClose = true;
            // Hide the cancel-button
            this.showCancelButton = false;
            // When all progress-observables are completed...
            rxjs.forkJoin(allProgressObservables).subscribe(function (end) {
                // ... the dialog can be closed again...
                _this.canBeClosed = true;
                _this.dialogRef.disableClose = false;
                // ... the upload was successful...
                _this.uploadSuccessful = true;
                // ... and the component is no longer uploading
                _this.uploading = false;
            });
        };
        UploadDialogComponent.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: UploadService }
        ]; };
        __decorate([
            core.ViewChild('file', { static: true })
        ], UploadDialogComponent.prototype, "file", void 0);
        UploadDialogComponent = __decorate([
            core.Component({
                selector: 'cp-upload-dialog',
                template: "<input type=\"file\" #file style=\"display: none\" (change)=\"onFilesAdded()\" multiple />\r\n\r\n<div mat-dialog-title id=\"title\">\r\n  <div>{{ uploadDialogTitle }}</div>\r\n  <button [disabled]=\"uploading || uploadSuccessful\" mat-raised-button color=\"primary\" class=\"add-files-btn\" (click)=\"addFiles()\">\r\n    {{ uploadDialogAddFilesButtonText }}\r\n  </button>\r\n</div>\r\n\r\n<div id=\"conflict\" *ngIf=\"existingFileConflict\">\r\n  {{ existingFileConflict }} already exists on the server and cannot be overwritten\r\n</div>\r\n\r\n<mat-dialog-content>\r\n  <mat-list>\r\n    <mat-list-item *ngFor=\"let file of files\">\r\n      <h4 mat-line>{{file.name}}</h4>\r\n      <mat-progress-bar *ngIf=\"progress\" mode=\"determinate\" [value]=\"progress[file.name].progress | async\"></mat-progress-bar>\r\n    </mat-list-item>\r\n  </mat-list>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions id=\"actions\">\r\n  <button *ngIf=\"showCancelButton\" mat-button mat-dialog-close>{{ uploadDialogCancelButtonText }}</button>\r\n  <button *ngIf=\"files.size > 0\" mat-raised-button color=\"primary\" [disabled]=\"!canBeClosed\" (click)=\"closeDialog()\">{{ primaryButtonText }}</button>\r\n</mat-dialog-actions>\r\n",
                styles: ["#title{display:flex;justify-content:space-between}#actions{display:flex;justify-content:flex-end}#conflict{font-size:.8em;color:red;margin-top:.5em}"]
            })
        ], UploadDialogComponent);
        return UploadDialogComponent;
    }());

    var UploadComponent = /** @class */ (function () {
        function UploadComponent(dialog, uploadService) {
            this.dialog = dialog;
            this.uploadService = uploadService;
            this.dialogClosed = new core.EventEmitter();
        }
        UploadComponent.prototype.ngOnInit = function () {
            this.uploadButtonText = this.uploadService.uploadButtonText ?
                this.uploadService.uploadButtonText :
                'Upload';
        };
        UploadComponent.prototype.openUploadDialog = function () {
            var _this = this;
            this.dialog.open(UploadDialogComponent, { width: '50%' })
                .afterClosed().subscribe(function () { return _this.dialogClosed.emit(); });
        };
        UploadComponent.ctorParameters = function () { return [
            { type: dialog.MatDialog },
            { type: UploadService }
        ]; };
        __decorate([
            core.Output()
        ], UploadComponent.prototype, "dialogClosed", void 0);
        UploadComponent = __decorate([
            core.Component({
                selector: 'cp-upload',
                template: '<button mat-raised-button (click)="openUploadDialog()">{{ uploadButtonText }}</button>'
            })
        ], UploadComponent);
        return UploadComponent;
    }());

    //#endregion
    var UploadModule = /** @class */ (function () {
        function UploadModule(parentModule) {
            if (parentModule) {
                throw new Error('UploadModule is already loaded. Import it in the AppModule only');
            }
        }
        UploadModule_1 = UploadModule;
        UploadModule.forRoot = function (uploadConfig) {
            return {
                ngModule: UploadModule_1,
                providers: [
                    UploadService,
                    { provide: UploadServiceConfig, useValue: uploadConfig }
                ]
            };
        };
        var UploadModule_1;
        UploadModule.ctorParameters = function () { return [
            { type: UploadModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        UploadModule = UploadModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    animations.BrowserAnimationsModule,
                    http.HttpClientModule,
                    button.MatButtonModule,
                    dialog.MatDialogModule,
                    list.MatListModule,
                    progressBar.MatProgressBarModule
                ],
                declarations: [
                    UploadComponent,
                    UploadDialogComponent
                ],
                exports: [
                    UploadComponent,
                    UploadDialogComponent
                ],
                entryComponents: [
                    UploadDialogComponent
                ]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf())
        ], UploadModule);
        return UploadModule;
    }());

    // This pipe whitelists URLs so that they aren't prefixed with 'unsafe:' when they render in the DOM
    var SafeUrlPipe = /** @class */ (function () {
        function SafeUrlPipe(domSanitizer) {
            this.domSanitizer = domSanitizer;
        }
        SafeUrlPipe.prototype.transform = function (value) {
            return this.domSanitizer.bypassSecurityTrustUrl(value);
        };
        SafeUrlPipe.ctorParameters = function () { return [
            { type: platformBrowser.DomSanitizer }
        ]; };
        SafeUrlPipe = __decorate([
            core.Pipe({
                name: 'safeUrl'
            })
        ], SafeUrlPipe);
        return SafeUrlPipe;
    }());

    var UriSchemePipe = /** @class */ (function () {
        function UriSchemePipe() {
        }
        // https://docs.microsoft.com/en-us/office/client-developer/office-uri-schemes
        UriSchemePipe.prototype.transform = function (value) {
            if (!localStorage.getItem('useUriScheme')) {
                return value;
            }
            var urlSplit = value.split('.');
            var extension = urlSplit[urlSplit.length - 1];
            if (!extension) {
                return value;
            }
            var command = this.command(extension);
            var app = this.app(extension);
            return "ms-" + app + ":" + command + "|u|" + value;
        };
        UriSchemePipe.prototype.app = function (extension) {
            switch (extension.toLowerCase()) {
                // documents
                case 'doc':
                case 'docx':
                case 'docm':
                case 'docb':
                case 'dot':
                case 'dotx':
                case 'dotm': // templates
                    return 'word';
                case 'xls':
                case 'xlsx':
                case 'xlm':
                case 'xlsm':
                case 'xlsb':
                case 'xlw':
                case 'xlt':
                case 'xltx':
                case 'xltm': // templates
                    return 'excel';
                case 'ppt':
                case 'pptx':
                case 'pps':
                case 'ppsx':
                case 'pptm':
                case 'ppsm':
                case 'sldx':
                case 'sldm':
                case 'pot':
                case 'potx':
                case 'potm': // templates
                    return 'powerpoint';
                case 'vsd':
                case 'vsdx':
                case 'vst':
                case 'vstx': // templates
                    return 'visio';
                case 'mdb':
                case 'accdb':
                case 'accde':
                case 'accdr':
                case 'accdt': // templates
                    return 'access';
                case 'mpp':
                case 'mppx':
                case 'mpt': // templates
                    return 'project';
                case 'pub':
                    return 'publisher';
                case 'xsn':
                    return 'infopath';
            }
        };
        UriSchemePipe.prototype.command = function (extension) {
            switch (extension.toLowerCase()) {
                case 'dot':
                case 'dotx':
                case 'dotm':
                case 'xlt':
                case 'xltx':
                case 'xltm':
                case 'pot':
                case 'potx':
                case 'potm':
                case 'vst':
                case 'vstx':
                case 'accdt':
                case 'mpt':
                    return 'nft'; // new from template
                default:
                    var openMode = 'v'; // for view, or 'e' or edit
                    return "of" + openMode; // default: open file as view/edit
            }
        };
        UriSchemePipe = __decorate([
            core.Pipe({
                name: 'uriScheme',
                pure: false
            })
        ], UriSchemePipe);
        return UriSchemePipe;
    }());

    //#endregion
    var UrlModule = /** @class */ (function () {
        function UrlModule() {
        }
        UrlModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    SafeUrlPipe,
                    UriSchemePipe
                ],
                exports: [
                    SafeUrlPipe,
                    UriSchemePipe
                ],
                entryComponents: []
            })
        ], UrlModule);
        return UrlModule;
    }());

    exports.AuthenticationModule = AuthenticationModule;
    exports.AuthenticationService = AuthenticationService;
    exports.AuthenticationServiceConfig = AuthenticationServiceConfig;
    exports.ConfirmationDialogComponent = ConfirmationDialogComponent;
    exports.DepartmentsPipe = DepartmentsPipe;
    exports.DialogModule = DialogModule;
    exports.EmailModule = EmailModule;
    exports.EmailService = EmailService;
    exports.EmailServiceConfig = EmailServiceConfig;
    exports.EmployeeByDnPipe = EmployeeByDnPipe;
    exports.EmployeeModule = EmployeeModule;
    exports.EmployeePhotoUrlPipe = EmployeePhotoUrlPipe;
    exports.EmployeeService = EmployeeService;
    exports.EmployeeServiceConfig = EmployeeServiceConfig;
    exports.EmployeesWithPropertyValuePipe = EmployeesWithPropertyValuePipe;
    exports.FilterEmployeesPipe = FilterEmployeesPipe;
    exports.InputDialogComponent = InputDialogComponent;
    exports.IsMemberOfPipe = IsMemberOfPipe;
    exports.LoginComponent = LoginComponent;
    exports.LoginFormComponent = LoginFormComponent;
    exports.MessageDialogComponent = MessageDialogComponent;
    exports.SafeUrlPipe = SafeUrlPipe;
    exports.SharePointModule = SharePointModule;
    exports.SharePointPhotoUrlPipe = SharePointPhotoUrlPipe;
    exports.SharePointService = SharePointService;
    exports.SharePointServiceConfig = SharePointServiceConfig;
    exports.SharePointUrlPipe = SharePointUrlPipe;
    exports.SortEmployeesPipe = SortEmployeesPipe;
    exports.UploadComponent = UploadComponent;
    exports.UploadDialogComponent = UploadDialogComponent;
    exports.UploadModule = UploadModule;
    exports.UploadService = UploadService;
    exports.UploadServiceConfig = UploadServiceConfig;
    exports.UriSchemePipe = UriSchemePipe;
    exports.UrlModule = UrlModule;
    exports.ɵa = DialogComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=cleavelandprice-ngx-lib.umd.js.map
